browser.runtime.onInstalled.addListener(() => {
	browser.contextMenus.create({
		"id": "addToFavinavi",
		"title": browser.i18n.getMessage("addToFavinavi"),
		"contexts": ["all"],
	});
});

const sendData = (data) => {
	browser.tabs.query({
		active: true,
		currentWindow: true
	}).then(tabs => {
		browser.tabs.sendMessage(tabs[0].id, data)
	});
};

browser.contextMenus.onClicked.addListener(function(item, tab) {
  sendData(item);
});
// 点击扩展图标
//browser.runtime.onMessage.addListener(function(data, sender, sendResponse) {
//  if (!tab.url.startsWith('browser://')) sendData(data);
//});
