browser.runtime.onMessage.addListener((data, sender, sendResponse) => {
	if(data.menuItemId && data.menuItemId=='addToFavinavi'){
		var favinaviPop,lu="",pu="";
		if(data.linkUrl)lu=data.linkUrl;
		if(data.pageUrl)pu=data.pageUrl;
		const login="<h2>"+chrome.i18n.getMessage("needLogin")+"</h2>"+
			"<a href='https://www.favii.cn/login' target='_blank' class='favinavi-btn' onclick='favinaviPop.style.display=\"none\";'>"+chrome.i18n.getMessage("loginBtn")+"</a>";
		const img="https://www.favii.cn/rightClickTool/images/";
		const loading="<div id='ldsWrap'><div class='favinavi-ring'><div></div><div></div><div></div></div></div>";
		const inner=
		"<div class='favinaviMask' id='faviCancel0'></div>"+
		"<div class='faviWrap'>"+
		"<div class='faviCancel' id='faviCancel1'>&#10006</div>"+
		"<img src='"+img+"favinavi32.png'/><h2>"+chrome.i18n.getMessage("addToFavinavi")+"</h2>"+
		"<div id='favinavi-content'>"+loading+
		"</div></div>";

		if(!document.getElementById('favinaviPop')){
			const cc="position:fixed;left:50%;top:50%;transform:translateX(-50%) translateY(-50%);";
			const wh="width:380px;min-height:240px;border-radius:6px;";
			var fvCss = document.createElement('style');
			const myCssText=
			".faviCancel{width:32px;height:32px;font-size:20px;line-height:32px;cursor:pointer;text-align:center;color:#888;position:absolute;top:8px;right:8px;}"+
			".faviCancel:hover{color:#666;background:#ccc;border-radius:50%;}"+
			".favinaviMask{all:initial;position:fixed;z-index:99990;left:0;top:0;width:100%;height:100%;text-align:center;background:#000;opacity:0.6;}"+
			".faviWrap{"+cc+wh+"z-index:99998;background:#fff;box-sizing:border-box;padding:16px 24px;text-align:left;font-family:Roboto, Noto, Helvetica, Arial, sans-serif;}"+
			"#ldsWrap{"+cc+"}"+
			"#favinavi-content{color:#333;box-sizing:border-box;padding-top:16px;}"+
			".favinavi-btn{margin:8px 0;cursor:pointer;font-size:16px;color:#eee!important;width:100%;height:36px;line-height:36px;background:#098;text-align:center;border-radius:4px;display:block;}"+
			".favinavi-btn:hover{background:#0a9;color:#fff;}"+
			".favinavi-sel{padding:0 8px;height:32px!important;line-height:32px!important;font-size:16px;color:#666;background:#fff;border:0;border-bottom:solid 1px #888;}"+
			".faviWrap img{width:32px;height:32px;vertical-align:middle;display:inline-block;}"+
			".faviWrap p{width:100%;height:32px;margin:0 0 8px 0;padding:0;line-height:32px;font-size:14px;font-weight:500;}"+
			".faviWrap input{width:100%;color:#333;background:#fff;height:32px!important;margin:0 0 8px 0;padding:0;line-height:32px!important;border:0;border-bottom:solid 1px #888;}"+
			".faviWrap input:focus,.faviWrap select:focus{outline:0;}"+
			".faviWrap h2{margin:0 0 0 16px;padding:0;color:#333;font-size:20px;line-height:32px;font-weight:900;vertical-align:middle;display:inline-block;}"+
			".favinavi-ring{display:inline-block;position:relative;margin:0 auto;width:32px;height:32px;}"+
			".favinavi-ring div{box-sizing:border-box;display:block;position:absolute;width:26px;height:26px;margin:8px 0;"+
			"border:3px solid #666;border-radius:50%;animation:favinavi-ring 1.2s cubic-bezier(0.5, 0, 0.5, 1) infinite;"+
			"border-color:#ccc transparent transparent transparent;}"+
			".favinavi-ring div:nth-child(1){animation-delay:-0.45s;}.favinavi-ring div:nth-child(2){animation-delay:-0.3s;}.favinavi-ring div:nth-child(3){animation-delay: -0.15s;}"+
			"@keyframes favinavi-ring{0%{transform: rotate(0deg);}100%{transform:rotate(360deg);}}";
			fvCss.innerHTML=myCssText;
			document.body.appendChild(fvCss);

			favinaviPop=document.createElement('DIV');
			favinaviPop.id='favinaviPop';
			document.body.appendChild(favinaviPop);
		}else{
			favinaviPop=document.getElementById('favinaviPop');
			favinaviPop.style.display='block';
		}
		favinaviPop.innerHTML=inner;
		document.getElementById('faviCancel0').addEventListener('click',()=>{
			favinaviPop.style.display="none";
		});
		document.getElementById('faviCancel1').addEventListener('click',()=>{
			favinaviPop.style.display="none";
		});

		fetch('https://www.favii.cn/rightClick',{
			method:"POST",
			body: 's='+encodeURIComponent(data.pageUrl),
			//JSON.stringify(postData),
			headers:{
				'Content-Type':'application/x-www-form-urlencoded'
				// 'Content-Type':'application/json'
			},
			credentials: 'include',//allow cookies
			mode: 'cors'
		})
		.then(response => response.json())
		.then(data => {
//			console.log(data);
			let c="<form name='addToFavinavi'>",
			lds=document.getElementById('ldsWrap'),
			fvc=document.getElementById('favinavi-content'),
			btn0=document.getElementById('favinavi-btn0');
			if(lds)lds.style.display='none';
			if(data['err']=='Invalid userInfo'){
				fvc.innerHTML=login;
				return;
			}
			var sel=chrome.i18n.getMessage("saveTo")+"<br/><select name='folders' id='favinavi-folder' class='favinavi-sel'>";
			for(let i=0,len=data.length;i<len;i++){
				sel+="<option value='"+data[i]['id']+"'/>"+data[i]['title']+"</option>";
			}
			sel+="</select>";
			if(lu)c+=chrome.i18n.getMessage("curLink")+"<p><input name='linkUrl' type='text' value='"+lu+"'/></p>"+sel+
			"<span class='favinavi-btn' id='favinavi-btn0'>"+chrome.i18n.getMessage("saveLink")+"</span>";
			if(pu)c+=chrome.i18n.getMessage("curPage")+"<p><input name='pageUrl' type='text' value='"+pu+"'/></p>"+sel+
			"<span class='favinavi-btn' id='favinavi-btn1'>"+chrome.i18n.getMessage("savePage")+"</span>";
			c+="</form>";
			fvc.innerHTML=c;
			var folders=document.getElementById('favinavi-folder');
			if(lu)document.getElementById('favinavi-btn0').addEventListener('click',()=>{
				fvc.innerHTML=loading;
				lds.style.display='block';
				let fid=folders.value;
				fetch('https://www.favii.cn/rightClickSave',{
					method:"POST",
					body: 's='+encodeURIComponent(pu)+'&l='+encodeURIComponent(lu)+'&fid='+fid,
					headers:{
						'Content-Type':'application/x-www-form-urlencoded'
					},
					credentials: 'include',
					mode: 'cors'
				})
				.then(response => response.json())
				.then(data => {
console.log(data);
					if(data['ok']){
						if(lds)lds.style.display='none';
						fvc.innerHTML="<h2>"+chrome.i18n.getMessage("saveOk")+"</h2>";
						setTimeout("favinaviPop.style.display='none';",1200);
					}else if(data['dup']){
						if(lds)lds.style.display='none';
						let dup=chrome.i18n.getMessage("dupLink").replace("#",data['dup']);
						fvc.innerHTML="<h2>"+dup+"</h2>";
						setTimeout("favinaviPop.style.display='none';",2000);
					}else if(data['err']){
						if(lds)lds.style.display='none';
						fvc.innerHTML="<h2>"+chrome.i18n.getMessage("saveFailed")+"</h2>";
						setTimeout("favinaviPop.style.display='none';",2000);
					}
				});
			});
			document.getElementById('favinavi-btn1').addEventListener('click',()=>{
				fvc.innerHTML=loading;
				lds.style.display='block';
				let fid=folders.value;
				fetch('https://www.favii.cn/rightClickSave',{
					method:"POST",
					body: 's='+encodeURIComponent(pu)+'&l='+encodeURIComponent(pu)+'&fid='+fid,
					headers:{
						'Content-Type':'application/x-www-form-urlencoded'
					},
					credentials: 'include',
					mode: 'cors'
				})
				.then(response => response.json())
				.then(data => {
console.log(data);
					if(data['ok']){
						if(lds)lds.style.display='none';
						fvc.innerHTML="<h2>"+chrome.i18n.getMessage("saveOk")+"</h2>";
						setTimeout("favinaviPop.style.display='none';",1200);
					}else if(data['dup']){
						if(lds)lds.style.display='none';
						let dup=chrome.i18n.getMessage("dupLink").replace("#",data['dup']);
						fvc.innerHTML="<h2>"+dup+"</h2>";
						setTimeout("favinaviPop.style.display='none';",2000);
					}else if(data['err']){
						if(lds)lds.style.display='none';
						fvc.innerHTML="<h2>"+chrome.i18n.getMessage("saveFailed")+"</h2>";
						setTimeout("favinaviPop.style.display='none';",2000);
					}
				});
			});
		});
//		window.open(data.selectionText ? url + data.selectionText : new URL(url).origin);
	}else return;
});
